
; *** CTRL - BREAK interupt

Proc    Err1_Int
        iret                            ; No action
EndP    Err1_Int




; *** Critical error handler

Proc    Err2_Int
        push    ds
        mov     ax,Data_Seg
        mov     ds,ax
        mov     [Byte ds:Crit_Error],1  ; Set own error flagg
        pop     ds
        xor     al,al                   ; Let DOS ignore error
        iret
EndP    Err2_Int





;             The Timer interupt

; Called 18,2 times a second. The heart of the
; andre Called 24,2 times a second. The heart of the

; game :)

Proc    Timer_Int
        push    ax ds
        mov     ax,Data_Seg
        mov     ds,ax
        sti

        cmp     [Byte ds:Menu_Active],0
        je      @@00



; *** Menu pallete stuff ***

        push    cx si di es
        push    ds                      ; ES = Data seg
        pop     es

; Rotate background pal        
        mov     si,Offset Pal_Rot
        mov     di,si

        mov     ax,[Word ds:Rot_Count]  ; Increase count
        push    ax                      ; Old count
        add     al,3
        cmp     al,3*4
        jb      @@01
        xor     al,al
@@01:   mov     [Word ds:Rot_Count],ax  ; New count

        add     di,ax                   ; DI = New possition
        pop     ax
        add     si,ax                   ; SI = New possition
        mov     cx,3
        rep     movsb

        mov     [Byte ds:si-3],00       ; Rewrite old color
        mov     [Byte ds:si-2],00
        mov     [Byte ds:si-1],50

        xor     [Byte ds:Currsor],1     ; Flash currsor

        pop     es di si cx
        jmp     @@99



; *** Game stuff ***

@@00:   cmp     [Byte ds:Playing],0
        je      @@99
        inc     [Byte ds:Update]


; *** Do the scrolling ***
        cmp     [Byte ds:Key_Map+01Dh],1; Don't do automatic scroll if
        je      @@70                    ; CTRL is down?
        cmp     [Byte ds:Key_Map+014h],1
        je      @@70

        mov     al,[Byte ds:Guy_H]
        sub     al,[Byte ds:Pos_H]      ; AL = Guy position - Map position

        cmp     [Byte ds:Scroll_H],1    ; Are we already in a scroll?
        je      @@50                    ; Yes, Increase
        ja      @@55                    ; Yes, Decrease

; Check if we shall start a scroll
        cmp     al,2                    ; Shall we start decreasing?
        jg      @@42

        mov     [Byte ds:Scroll_H],2    ; Start decreasing
        jmp     @@55

@@42:   cmp     al,30-2-1               ; Shall we start increasing?
        jl      Vertical
        inc     [Byte ds:Scroll_H]      ; Start increasing


; We allready are in a scroll

; Increase
@@50:   mov     ah,[Byte ds:Map_H]      ; Check if we reached the end
        sub     ah,30
        cmp     [Byte ds:Pos_H],ah
        je      @@51                    ; Yes, skipp and stopp
        inc     [Byte ds:Pos_H]


; Check if we shall stopp scrolling
        cmp     al,30/2                 ; Midle of the screen?
        ja      Vertical                ; Don't stopp
@@51:   mov     [Byte ds:Scroll_H],0    ; Stopp
        jmp     Vertical


; Decrease
@@55:   cmp     [Byte ds:Pos_H],0       ; Check if we reached the end
        je      @@51                    ; Yes, skipp and stopp
        dec     [Byte ds:Pos_H]
        cmp     al,30/2                 ; Check if we shall stopp scrolling
        jae     @@51                    ; Stopp



; Vertical scrolling
Vertical:
        mov     al,[Byte ds:Guy_V]
        sub     al,[Byte ds:Pos_V]      ; AL = Guy position - Map position

        cmp     [Byte ds:Scroll_V],1    ; Are we already in a scroll?
        je      @@60                    ; Yes, Increase
        ja      @@65                    ; Yes, Decrease

; Check if we shall start a scroll
        cmp     al,2                    ; Shall we start decreasing?
        jg      @@59

        mov     [Byte ds:Scroll_V],2    ; Start decreasing
        jmp     @@65

@@59:   cmp     al,19-2-1               ; Shall we start increasing?
        jl      @@70
        inc     [Byte ds:Scroll_V]      ; Start increasing
        ;jmp     @@60

; We allready are in a scroll

; Increase
@@60:   mov     ah,[Byte ds:Map_V]      ; Check if we reached the end
        sub     ah,19
        cmp     [Byte ds:Pos_V],ah
        je      @@61                    ; Yes, skipp and stopp
        inc     [Byte ds:Pos_V]

; Check if we shall stopp scrolling
        cmp     al,19/2                 ; Midle of the screen?
        ja      @@70                    ; Don't stopp
@@61:   mov     [Byte ds:Scroll_V],0    ; Stopp
        jmp     @@70


; Decrease
@@65:   cmp     [Byte ds:Pos_V],0       ; Check if we reached the end
        je      @@61                    ; Yes, skipp and stopp
        dec     [Byte ds:Pos_V]

; Check if we shall stopp scrolling
        cmp     al,19/2
        jae     @@61                    ; Stopp



; *** Syncronize stuff ***


; *** Extra life fading ***
@@70:   mov     ah,[Byte ds:Extra_life]
        or      ah,ah
        jz      @@05
        mov     al,7
        test    ah,10000000b
        jz      @@72
        mov     al,-7

@@72:   add     [Byte ds:Pal+33*3],al   ; Fade collor 33
        add     [Byte ds:Pal+33*3+1],al
        add     [Byte ds:Pal+33*3+2],al

        cmp     [Byte ds:Pal+33*3],0    ; Time to fade up?
        jne     @@73
        and     ah,01111111b
        jmp     @@75

@@73:   cmp     [Byte ds:Pal+33*3],7*5  ; Time to fade down?
        jb      @@75
        or      ah,10000000b

@@75:   mov     al,ah                   ; Count down
        and     al,01111111b
        dec     ah
        mov     [Byte ds:Extra_Life],ah
        dec     al
        jnz     @@05
        mov     [Byte ds:Extra_Life],0


; ** Futher stuff ***
@@05:   ;....


; Change frame counter for monster 1 (Fast)
        dec     [Byte ds:Frame4]
        jns     @@10
        mov     [Byte ds:Frame4],2


; Delay to slow down animation and game play
@@10:   dec     [Byte ds:Delay]
        jnz     @@99
        mov     [Byte ds:Delay],_Delay
        inc     [Byte ds:Update2]


; Change other frame counters
@@17:   xor     [Byte ds:Frame1],1
        inc     [Byte ds:Frame2]
        cmp     [Byte ds:Frame2],3
        jne     @@20
        mov     [Byte ds:Frame2],0
@@20:   dec     [Byte ds:Frame3]
        jns     @@30
        mov     [Byte ds:Frame3],3

@@30:   cmp     [Byte ds:Pause],1       ; Skipp if pause
        je      @@99

; Delay the green stuff
        dec     [Byte ds:Green_Delay]
        jns     @@98
        mov     [Byte ds:Green_Delay],8


; Countdown time
@@98:   cmp     [Byte ds:Finished],3    ; Skipp if finished
        jae     @@99
        dec     [Word ds:Time]
        mov     ax,[Word ds:Time]
        cmp     ax,(11*16)-1            ; Only 10 ticks left
        jne     @@15
        mov     [Byte ds:Time_Color],26 ; Make time red
@@15:   cmp     [Word ds:Wall_Finished],ax
        jne     @@99
        inc     [Byte ds:Wall_Status]   ; Turn of special brick wall


; Jump to old INT 08h handler
@@99:   pop     ds ax
        cli
        jmp     [Dword cs:Int_08h]
EndP    Timer_Int





;        The Keyboard Handler

; I keep a status map of all the keys
; I also save the last pressed key
; This routine also check for parity,
; recive and time out errors

Proc    Keyb_Int
        push    ax bx cx ds
        mov     ax,Data_Seg
        mov     ds,ax

        cmp     [Byte ds:BIOS_Keyb],0   ; Use own handler
        je      @@00

        pop     ds cx bx ax             ; Jump to BIOS handler
        jmp     [Dword cs:Int_09h]

@@00:   in      al,064h                 ; Test for parity and recive errors
        test    al,11000000b
        jz      @@10

        inc     [Byte ds:Keyb_Error]    ; Set error flagg and return
        jmp     @@99


; Wait for a byte to be available
@@10:   xor     cx,cx
@@20:   in      al,064h
        IODELAY
        test    al,0001b
        jnz     Key_Ready
        loop    @@20

        inc     [Byte ds:Keyb_Error]    ; Timeout
        jmp     @@99


Key_Ready:
        in      al,60h                  ; Get key
        xor     ah,ah                   ; Assume we shall clear key
        or      al,al
        js      @@30
        inc     ah                      ; Set key

@@30:   and     al,01111111b            ; Clear relase bit
        movzx   bx,al
        or      ah,ah                   ; Clear key?
        jz      @@90                    ; Yes, skipp key testing


; Test for ESC        
        cmp     al,01h                  ; ESC?
        jne     @@40
        mov     [Byte ds:ESC_Flagg],1
        cmp     [Byte ds:Key_Map+0Fh],1 ; Is TAB down?
        jne     @@99
        inc     [Byte ds:ESC_Flagg]     ; Yes, sett TAB-ESC flagg
        jmp     @@99


; Test for space bar
@@40:   cmp     al,39h                  ; Space?
        jne     @@45
        cmp     [Byte ds:Playing],0     ; Skipp if NOT playing
        je      @@99
        cmp     [Byte ds:Finished],2    ; Skipp if in goal or dead
        ja      @@99
        cmp     [Byte ds:Pause],0       ; Set/Clear pause?
        je      @@42
        mov     [Byte ds:Pause],0       ; Clear pause
        mov     [Word ds:Info_String],Offset Status_String
        mov     [Byte ds:Char_Space],3
        mov     [Byte ds:Update],0
        mov     [Byte ds:Update2],0
        jmp     @@99

@@42:   mov     [Byte ds:Pause],1      ; Set pause
        mov     [Word ds:Info_String],Offset Pause_Str
        mov     [Byte ds:Char_Space],2
        jmp     @@99


; *** Key scrolling ***
@@45:   mov     cl,[Byte ds:Map_V]
        sub     cl,[Byte ds:Pos_V]      ; CL = Guy position - Map position

        cmp     al,050h                 ; Down?
        jne     @@50
        cmp     cl,19
        je      @@80
        inc     [Byte ds:Pos_V]
        jmp     @@80

@@50:   cmp     al,048h                 ; Up?
        jne     @@55
        cmp     [Byte ds:Pos_V],0
        je      @@80
        dec     [Byte  ds:Pos_V]
        jmp     @@80

@@55:   mov     cl,[Byte ds:Map_H]      ; CL = Guy position - Map position
        sub     cl,[Byte ds:Pos_H]

        cmp     al,04Bh                 ; Left
        jne     @@60
        cmp     [Byte ds:Pos_H],0
        je      @@80
        dec     [Byte ds:Pos_H]
        jmp     @@80

@@60:   cmp     al,04Dh                 ; Right?
        jne     @@65
        cmp     cl,30
        je      @@80
        inc     [Byte ds:Pos_H]
        jmp     @@80


; Futer keys...
@@65:   ;jmp     @@80


@@80:   mov     [Byte ds:Last_Key],al   ; Save last key
@@90:   mov     [Byte ds:Key_Map+bx],ah ; Set/Clear key
        or      ah,ah
        jz      @@99

@@99:   mov     al,20h                  ; EOI
        out     20h,al
        pop     ds cx bx ax

        iret
EndP    Keyb_Int



; *** Data in Code Segment ***
Int_08h         dd      0
Int_09h         dd      0
