
;             The Mouse interupt

Proc    Mouse_Int
        mov     ax,Data_Seg
        mov     ds,ax

        and     bl,00000111b
        or      bl,bl                   ; Skipp if no buttons is down
        jz      @@99
        push    bx                      ; Save button status
        push    dx                      ; Save Y


; Find screen position
        mov     si,Offset Map

        mov     al,[Byte ds:Pos_V]
        mul     [Byte ds:Map_H]         ; in map
        add     al,[Byte ds:Pos_H]
        adc     ah,0
        add     si,ax                   ; SI = Left corner


; Find mouse position        
        mov     ax,cx                   ; CX = X
        shl     ax,6
        xor     dx,dx                   ; AX:DX = X cordinate * 64
        mov     bx,114*12
        div     bx                      ; AX = X cordinate (0 - 29)
        mov     bp,ax

        pop     ax                      ; Restore Y
        shl     ax,6
        xor     dx,dx                   ; AX:DX = Y cordinate * 64
        mov     bx,57*12
        div     bx                      ; AX = Y cordinate (0 - 19)

        mul     [Byte ds:Map_H]         ; Find vertical
        add     ax,bp                   ; Add horizontal
        add     si,ax                   ; SI = Position to use


; Find out witch button is down?
        pop     ax                      ; AL = Button status
        test    al,0001b                ; Left button?
        jz      @@10
        movzx   bx,[Byte ds:Draw_Type]  ; Yes, get current icon
        mov     ah,[Byte ds:Type_Table+bx]
        jmp     @@80

@@10:   test    al,0010b                ; Right button?
        jz      @@20
        xor     ah,ah                   ; Yes, clear position
        jmp     @@80

@@20:   mov     ah,1                    ; Must be middle button (Unexplored)

@@80:   mov     [Byte ds:si],ah         ; Write new icon
@@99:   retf
EndP    Mouse_Int






;             The Timer interupt

;  Just some sync stuff...
;

Proc    Timer_Int
        push    ax ds
        mov     ax,Data_Seg
        mov     ds,ax
        sti

        inc     [Byte ds:Update]


; Fading
        mov     al,[Byte ds:Pal+33*3]
        add     al,20
        mov     [Byte ds:Pal+33*3],al
        mov     al,[Byte ds:Pal+33*3+1]
        add     al,20
        mov     [Byte ds:Pal+33*3+1],al
        mov     al,[Byte ds:Pal+33*3+2]
        add     al,20
        mov     [Byte ds:Pal+33*3+2],al


; Change frame counter for monster 1 (Fast)
        dec     [Byte ds:Frame4]
        jns     @@10
        mov     [Byte ds:Frame4],2


; Delay to slow down animation
@@10:   dec     [Byte ds:Delay]
        jnz     @@99
        mov     [Byte ds:Delay],_Delay


; Change other frame counters
@@17:   xor     [Byte ds:Frame1],1
        inc     [Byte ds:Frame2]
        cmp     [Byte ds:Frame2],3
        jne     @@20
        mov     [Byte ds:Frame2],0
@@20:   dec     [Byte ds:Frame3]
        jns     @@99
        mov     [Byte ds:Frame3],3


; Jump to old INT 08h handler
@@99:   pop     ds ax
        cli
        jmp     [Dword cs:Int_08h]
EndP    Timer_Int



; *** Data in Code Segment ***
Int_08h         dd      0




;        The Keyboard Handler

; Keep a status map of all the keys
; currently upp or down

Proc    Keyb_Int
        push    ax bx cx ds
        mov     ax,Data_Seg
        mov     ds,ax


; Wait for a byte to be available
@@10:   xor     cx,cx
@@20:   in      al,064h
        IODELAY
        test    al,0001b
        jnz     Key_Ready
        loop    @@20

        jmp     @@99


Key_Ready:
        in      al,60h                  ; Get key
        xor     ah,ah                   ; Assume we shall clear key
        or      al,al
        js      @@30
        inc     ah                      ; Set key

@@30:   and     al,01111111b            ; Clear relase bit
        movzx   bx,al
        or      ah,ah                   ; Clear key?
        jz      @@90                    ; Yes, skipp key testing


; Test for different keys
        cmp     al,01h                  ; ESC?
        jne     @@40
        mov     [Byte ds:ESC_Flagg],1
        cmp     [Byte ds:Key_Map+0Fh],1 ; TAB down?
        jne     @@99
        inc     [Byte ds:ESC_Flagg]
        jmp     @@99

@@40:   cmp     al,04Ah                 ; Gray -
        jne     @@42
        cmp     [Byte ds:Draw_Type],0
        je      @@99
        dec     [Byte ds:Draw_Type]
        jmp     @@99

@@42:   cmp     al,04Eh                 ; Gray +
        jne     @@44
        cmp     [Byte ds:Draw_Type],10
        je      @@99
        inc     [Byte ds:Draw_Type]
        jmp     @@99

; Test for F1 to F11
@@44:   cmp     al,03Bh                 ; F1
        jb      @@50
        cmp     al,044h                 ; F10
        jbe     @@46
        cmp     al,057h                 ; F11
        jne     @@50
        sub     al,057h-045h            ; Convert scancode to 45h

@@46:   sub     al,03Bh
        mov     [Byte ds:Draw_Type],al
        jmp     @@99


; Futre keys...
@@50:   jmp     @@90


@@90:   mov     [Byte ds:Key_Map+bx],ah ; Set/Clear key

@@99:   mov     al,20h                  ; EOI
        out     20h,al
        pop     ds cx bx ax

        iret
EndP    Keyb_Int
